寻找重复数

寻找重复数

给定一个包含 n + 1 个整数的数组 nums ,其数字都在 [1, n] 范围内(包括 1 和 n),可知至少存在一个重复的整数。

假设 nums 只有 一个重复的整数 ,返回 这个重复的数 。

你设计的解决方案必须 不修改 数组 nums 且只用常量级 O(1) 的额外空间。

示例 1:

复制代码
输入:nums = [1,3,4,2,2]
输出:2

示例 2:

复制代码
输入:nums = [3,1,3,4,2]
输出:3

示例 3 :

复制代码
输入:nums = [3,3,3,3,3]
输出:3

题解:

​ 题目乍一看非常简单,但是有两个限制条件,只用常量级 O(1) 的额外空间,则不能使用哈希表,不修改 数组,则没办法进行排序或者其他操作;排除这两种想法的情况下,再考虑如何不使用 n^2 的暴力枚举优化时间复杂度其实是一件蛮困难的事情

不能只用常量级 O(1) 的额外空间

go 复制代码
func findDuplicate(nums []int) int {
    m := make(map[int]int)
    for i := 0; i < len(nums); i++ {
        if m[nums[i]] == 1 {
            return nums[i]
        }
        m[nums[i]] = 1
    }
    return -1
}

不能修改 数组

go 复制代码
func findDuplicate(nums []int) int {
	for nums[0] != nums[nums[0]] {
		nums[0], nums[nums[0]] = nums[nums[0]], nums[0]
	}
	return nums[0]
}

这里可以注意到,对于 1-n 的数字,有 n+1个位置,其中有一个重复的数,那么如果重复的数字为 tar,我们统计小于等于 i 的数量,只有当 i < tar 的情况下,得到的结果是等于 i 本身的,根据这个性质我们可以把 n ^ 2 的外层循环,优化为 logn

go 复制代码
func findDuplicate(nums []int) int {
    l, r := 0, len(nums)-1
    ans := -1
    for l <= r {
        mid := (l + r) / 2
        cnt := 0
        for i := 0; i < len(nums); i++ {
            if nums[i] <= mid {
                cnt++
            }
        }
        if cnt <= mid {
            l = mid + 1
        } else {
            r = mid - 1
            ans = mid
        }
    }
    return ans
}
相关推荐
m0_639906941 小时前
Redis入门|五种数据结构、使用场景、持久化RDB&AOF
数据结构·数据库·redis
ZhengEnCi2 小时前
Agent 架构怎么选:从单 Agent 到多 Agent 编排的选型决策指南
算法·架构
秋天的怀念_David3 小时前
第二十二夜 · 数字迷雾
java·程序人生·算法
Pniubi3 小时前
力扣283移动零(双指针法)
算法·leetcode·职场和发展
hhb_6184 小时前
大模型落地三重优化实战
人工智能·算法·机器学习
云和数据.ChenGuang4 小时前
光哥说Python RAG 系统需要哪些评估指标:从检索到生成的全链路评测指南
网络·人工智能·python·算法·langchain
2601_970703835 小时前
工业除湿机租赁:把一份租金合同拆开看
大数据·数据结构·算法·数据库架构·推荐算法
心中有你02145 小时前
Java实现Dijkstra最短路径算法(邻接表 + 优先队列)
java·数据库·算法
ZhengEnCi6 小时前
同样的模型,为什么本地和云 API 差别那么大:量化精度、聊天模板与采样参数的三大元凶
人工智能·算法·llm
Flynn Liang7 小时前
RAG 答非所问/幻觉怎么破?Spring AI QuestionAnswerAdvisor 召回优化实战(TopK/重排/混合检索)
人工智能·算法·spring·rag·幻觉·springai